
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C++ 仿函数/函数指针/闭包lambda / iVAN</title>

    <meta name="description" content="C++ 仿函数/函数指针/闭包lambda 在上一篇文章中介绍了C++11新引入的lambda表达式(C++支持闭包的实现),现在我们看一下lambda的出现对于我们编程习惯的影响,毕竟,C++11历经10年磨砺,出140新feature,对于我们的programming idiom有深远影响.我们先看一下是不是lambda的出现对于仿函数的影响. 1) 仿函数 wikipedia 的定义: A function object, also called a functor, functional, or functionoid, is a">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">C++ 仿函数/函数指针/闭包lambda</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在上一篇文章中介绍了C++11新引入的lambda表达式（C++支持闭包的实现），现在我们看一下lambda的出现对于我们编程习惯的影响，毕竟，C++11历经10年磨砺，出140新feature，对于我们的programming idiom有深远影响。我们先看一下是不是lambda的出现对于仿函数的影响。</p>
<p>1） 仿函数</p>
<p>wikipedia 的定义：</p>
<table>
<tbody>
<tr>
<td>A function object, also called a functor, functional, or functionoid, is a computer programming construct allowing an object to be invoked or called like it was an ordinary function, usually with the same syntax.</td>
</tr>
</tbody>
</table>
<p>Functor/Function Object翻译过来就是仿函数。它是通过重载()运算符模拟函数形为的类。也就是说，它不是函数（所以仿函数翻译的很贴切）。因为它重载了()运算符，因此可以像调用函数一样对它进行调用。STL中大量运用了Function Object，也提供了很多预先定义的Function Object。还是从vector遍历举例：</p>
<pre>class PrintInt
{
public:
    void operator()(int elem) const
    {
        std::cout&lt;&lt;elem&lt;&lt;' ';
    }
};

std::vector&lt;int&gt; v;
for_each(v.begin(),v.end(), PrintInt()); 

//C++ 11 lambda stype
for_each(begin(v), end(v), [](int n){ cout&lt;&lt; n &lt;&lt;", "; });</pre>
<p>仿函数的优点：</p>
<p>1.仿函数是对象，可以拥有成员函数和成员变量，即仿函数拥有状态(states)<br />
2.每个仿函数都有自己的类型<br />
3.仿函数通常比一般函数快（很多信息编译期确定）</p>
<p>首先简单看一下for_each的源码：</p>
<pre>// TEMPLATE FUNCTION for_each
template&lt;class _InIt,
    class _Fn1&gt; inline
    _Fn1 for_each(_InIt _First, _InIt _Last, _Fn1 _Func)
    {    // perform function for each element

    _DEBUG_RANGE(_First, _Last);
    _DEBUG_POINTER(_Func);
    _CHECKED_BASE_TYPE(_InIt) _ChkFirst(_CHECKED_BASE(_First));
    _CHECKED_BASE_TYPE(_InIt) _ChkLast(_CHECKED_BASE(_Last));
    for (; _ChkFirst != _ChkLast; ++_ChkFirst)
        _Func(*_ChkFirst);
    return (_Func);
    }

//effective STL
template&lt; typename InputIterator, typename Function &gt;
Function for_each( InputIterator beg, InputIterator end, Function f ) {
    while ( beg != end )
        f( *beg++ );
}</pre>
<p>简单来说， for_each就是一个模板函数，将for循环语句封装起来，前面两个参数都是迭代器，第三个参数是使用一个函数指针（或仿函数），其功能是对每一个迭代器所指向的值调用仿函数。<br />STL包括了许多不同的预定义的函数对象，包括算子(plus,minus,multiplies,divides,modulus和negate)，算术比较(equal_to,not_equal_to,greater,less,greater_equal和less_equal)，和逻辑操作(logical_and,logical_or和logical_not)。这样你就可以不用手动写新的函数对象而是用这些函数对象就可以组合出相当复杂的操作。</p>
<p>当然，为了仅仅是遍历vector并且输出，可以使用更简单的方式，我们第一个例子仅仅是为了说明仿函数怎么用。</p>
<pre>copy(v.begin(), v.end(), std::ostream_iterator&lt;int&gt;(std::cout," "));</pre>
<p>其实通过lambda，很多STL的仿函数可以不用。但是既然有轮子了，所以如果了解或者会使用这些仿函数，无疑会更能优美、高效的编写代码。</p>
<p>使用std::negate&lt;int&gt;()进行数组元素求反：</p>
<pre>transform( vect.begin(), vect.end(), vect.begin(), std::negate&lt;int&gt;() ); 

// TEMPLATE STRUCT negate
template&lt;class _Ty&gt;   struct negate         : public unary_function&lt;_Ty, _Ty&gt;
 { // functor for unary operator-
   _Ty operator()(const _Ty&amp; _Left) const
     { // apply operator- to operand
       return (-_Left);
     }
};
</pre>
<p>将容器中所有小于5的元素删除。</p>
<pre>auto iter = std::remove_if( ivec.begin(), ivec.end(), std::bind2nd( std::less&lt;int&gt;(), 5 ) );
ivec.erase( iter, ivec.end() );</pre>
<p>关于std::less&lt;int&gt;</p>
<pre>// TEMPLATE STRUCT less
template&lt;class _Ty&gt;
    struct less
        : public binary_function&lt;_Ty, _Ty, bool&gt;
    { // functor for operator&lt;
    bool operator()(const _Ty&amp; _Left, const _Ty&amp; _Right) const
        { // apply operator&lt; to operands
        return (_Left &lt; _Right);
        }
    };</pre>
<p>关于bind2nd的实现，实现过程也有仿函数的运用：</p>
<pre>// TEMPLATE FUNCTION bind2nd
template&lt;class _Fn2,
    class _Ty&gt; inline
    binder2nd&lt;_Fn2&gt; bind2nd(const _Fn2&amp; _Func, const _Ty&amp; _Right)
    { // return a binder2nd functor adapter

    typename _Fn2::second_argument_type _Val(_Right);
    return (std::binder2nd&lt;_Fn2&gt;(_Func, _Val));
    }

// TEMPLATE CLASS binder2nd
template&lt;class _Fn2&gt;
    class binder2nd
        : public unary_function&lt;typename _Fn2::first_argument_type,
            typename _Fn2::result_type&gt;
    { // functor adapter _Func(left, stored)
public:
    typedef unary_function&lt;typename _Fn2::first_argument_type,
        typename _Fn2::result_type&gt; _Base;
    typedef typename _Base::argument_type argument_type;
    typedef typename _Base::result_type result_type;

    binder2nd(const _Fn2&amp; _Func,
        const typename _Fn2::second_argument_type&amp; _Right)
        : op(_Func), value(_Right)
        { // construct from functor and right operand

        }

    result_type operator()(const argument_type&amp; _Left) const
        { // apply functor to operands

        return (op(_Left, value));
        }

    result_type operator()(argument_type&amp; _Left) const
        { // apply functor to operands

        return (op(_Left, value));
        }

protected:
    _Fn2 op; // the functor to apply
    typename _Fn2::second_argument_type value; // the right operand
};</pre>
<p>综上所述，由于STL内置的仿函数功能强大，因此如果熟悉的话可以加以利用。否则，使用lambda也是不错的选择，毕竟，都能写出优雅的代码。</p>
<p>如果非要细分的话，lambda什么时候可以替代仿函数？我们需要从lambda的限制说起。这一点很大程度上是由lambda的捕捉列表的限制造成的。在现行C++11的标准中，捕捉列表仅能捕捉父作用域的自动变量。比如下面这个例子：</p>
<pre> int d = 0;
 void test()
 {
    auto ill_lambda = [d]{};
 }</pre>
<p>g++会编译通过，但是会有warning。而一些严格遵照C++11标准的编译器则会直接报错。仿函数则没有次限制。</p>
<p>简单总结一下，使用lambda替代仿函数应该满足一下几个条件：</p>
<p>a) 是局限于一个局部作用域中使用的代码逻辑。</p>
<p>b) 这些代码逻辑需要作为参数进行传递。</p>
<p>lambda被设计的主要目的之一就是简化仿函数的使用，虽然语法看起来不像是“典型的C++”， 但是一旦熟悉之后，程序员就能准确的编写一个简单的，就地的，带状态的函数定义。当然了，如果需要全局共享的代码逻辑，我们还是需要用函数（无状态）或者仿函数（有状态）封装起来。</p>
<p>引用：<br /><a href="http://blog.chinaunix.net/uid-20384806-id-1954378.html" rel="external nofollow noreferrer">http://blog.chinaunix.net/uid-20384806-id-1954378.html</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 06:22:22</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>C++ 仿函数/函数指针/闭包lambda的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7mPOz.html" rel="bookmark">匿名函数、闭包、lambda表达式、Block</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C#有lambda.匿名函数,js有匿名函数.闭包,OC中有block,看到这是不是心中有一万个草泥马在跑,不过它们这些都是换汤不换药,不同语言名字不一样. 从功能性上说lambda和closure(或是OC中的blocks)是一个东西,只是不同语言的不同称呼罢了,它们都是匿名函数.若匿名函数捕获了一个外部变量,那么它就是一个closure. 为什么会有这个东东呢? 使用它们一般会有两个好处:简洁.捕获变量. 1.简洁 比如一个方法只在这一处使用,我们就没有必要创建方法然后调用,我们可以直接在其			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVN78kz.html" rel="bookmark">成员函数指针与高性能的C&plus;&plus;委托 &lpar;Member Function Pointers and the Fastest Possible C&plus;&plus; Delegates&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标准C++中没有真正的面向对象的函数指针.这一点对C++来说是不幸的,因为面向对象的指针(也叫做&quot;闭包(closure)&quot;或&quot;委托(delegate)&quot;)在一些语言中已经证明了它宝贵的价值.在Delphi (Object Pascal)中,面向对象的函数指针是Borland可视化组建库(VCL,Visual Component Library)的基础.而在目前,C#使&quot;委托&quot;的概念日趋流行,这也正显示出C#这种语言的成功.在很多应用程序中,&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z440VJz.html" rel="bookmark">JavaScript基础篇（6）之函数表达式闭包&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 其实js支持函数闭包的主要原因是因为js需要函数能够保存数据.这里的保存数据是只函数在运行结束以后函数内变量的值也会进行保存.至于为什么js需要在函数内可以保存数据,那就是js是一种函数式语言.在函数内保存数据是函数式语言的一大特征. 回顾前面介绍过的三种定义函数方式 functiosu(numnumreturnunum//函数声明语法定义 vasufunction(numnum)returnunum}//函数表达式定义 vasuneFunction(&quot;num&quot;&quot;num&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWxJZ7p.html" rel="bookmark">谈谈JavaScript中的函数与闭包&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				闭包这东西,说难也难,说不难也不难,下面我就以自己的理解来说一下闭包 一.闭包的解释说明 对于函数式语言来说,函数可以保存内部的数据状态.对于像C#这种编译型命令式语言来说,由于代码总是在代码段中执行,而代码段是只读的,因此函数中的数据只能是静态数据.函数内部的局部变量存放在栈上,在函数执行结束以后,所占用的栈被释放,因此局部变量是不能保存的. Javascript采用词法作用域,函数的执行依赖于变量作用域,这个作用域是在定义函数时确定的.因此Javascript中函数对象不仅保存代码逻辑,还必			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgNe8b.html" rel="bookmark">编程算法：求1&plus;2&plus;&period;&period;&period;&plus;n&lpar;函数指针&rpar; 代码&lpar;C&plus;&plus;&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: 求1+2+...+n, 要求不能使用乘除法\for\while\if\else\switch\case等关键字及条件判断语句(A?B:C). 可以使用函数指针求解, 通过递归调用, 每次递归值减1, 使用求反运算(!), 即非0为0, 0为1. 代码: /* * main.cpp * * Created on: 2014.7.12 *本栏目更多精彩内容:http://www.bianceng.cnhttp://www.bianceng.cn/Programming/sjjg/ * Aut			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4Pa7p.html" rel="bookmark">谈函数指针&lpar;全局&sol;类成员函数&rpar;和函数对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数指针(全局函数/类成员函数).函数对象(Function object) 一. 函数指针类型为全局函数. #include &quot;stdafx.h&quot;#include &lt;iostream&gt;using namespace std;class TestAction;typedef void (*fp)(int); void Drink(int i){ cout&lt;&lt;&quot;No. &quot;&lt;&lt;i&lt;&lt;&quot; drink...&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4wJoPp.html" rel="bookmark">声明函数指针并实现回调</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序员常常需要实现回调.本文将讨论函数指针的基本原则并说明如何使用函数指针实现回调.注意这里针对的是普通的函数,不包括完全依赖于不同语法和语义规则的类成员函数(类成员指针将在另文中讨论). 声明函数指针 回调函数是一个程序员不能显式调用的函数:通过将回调函数的地址传给调用者从而实现调用.要实现回调,必须首先定义函数指针.尽管定义的语法有点不可思议,但如果你熟悉函数声明的一般方法,便会发现函数指针的声明与函数声明非常类似.请看下面的例子: void f():// 函数原型 上面的语句声明了一个函数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm7j9lb.html" rel="bookmark">C&sol;C&plus;&plus;中函数指针的含义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数存放在内存的代码区域内,它们同样有地址,我们如何能获得函数的地址呢? 如果我们有一个int test(int a)的函数,那么,它的地址就是函数的名字,这一点如同数组一样,数组的名字就是数组的起始地址. 定义一个指向函数的指针用如下的形式,以上面的test()为例: int (*fp)(int a);//这里就定义了一个指向函数的指针 函数指针不能绝对不能指向不同类型,或者是带不同形参的函数,在定义函数指针的时候我们很容易犯如下的错误. int *fp(int a);//这里是错误的,因为按			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW15Lnz.html" rel="bookmark">C&plus;&plus;指针探讨&lpar;三&rpar;成员函数指针</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C语言的指针相当的灵活方便,但也相当容易出错.许多C语言初学者,甚至C语言老鸟都很容易栽倒在C语言的指针下.但不可否认的是,指针在C语言中的位置极其重要,也许可以偏激一点的来说:没有指针的C程序不是真正的C程序. 然而C++的指针却常常给我一种束手束脚的感觉.C++比C语言有更严格的静态类型,更加强调类型安全,强调编译时检查.因此,对于C语言中最容易错用的指针,更是不能放过:C++的指针被分成数据指针,数据成员指针,函数指针,成员函数指针,而且不能随便相互转换.而且这些指针的声明格式都不一样:			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMALRJb.html" rel="bookmark" class="title">百度绿萝算法2&period;0更新 站长该何去何从</a>
					<div>
						百度绿萝算法2.0最新公告:针对一些网站到处发布推广性软文的现象,一直以来我们都在通过各种方式进行处理.一方面,过滤清理这种垃圾外链;另一方面,对目标站点进行适当惩罚.现在各个站长网到处都有这种公告信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeAjAz.html" rel="bookmark" class="title">PS基础教程：为照片添加圆角矩形边框</a>
					<div>
						今天我们一起学习下[形状工具]的使用:[文件][打开]宝宝照片,选择形状工具的圆角矩形工具,如下图 公共栏选择如下(半径越大,圆角的幅度就越大): 在照片拉出我们形状路径.如图: 按[ctrl]+[e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrxj6z.html" rel="bookmark" class="title">Visual Basic动态数据驱动程序浅析</a>
					<div>
						Visual Basic应用程序经常使用先进的ActiveX组件连接到数据源.这些数据来源可能包括数据访问对象(DAO)的使用,远程数据对象(RDO),OLE DB提供程序,如ActiveX数据对象( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPW98z.html" rel="bookmark" class="title">Excel小技巧：双击的妙用</a>
					<div>
						1．巧分窗口 如果仔细观察可能会发现,在Excel垂直滚动条上方与带黑三角形按钮相邻的地方,有一个折叠起来的按钮,双击(以下双击均指双击鼠标左键)它,即可将当前窗口上下一分为二:双击水平滚动条右方的折 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4qyOp.html" rel="bookmark" class="title">flash player安装为什么老是错误</a>
					<div>
						  flash player安装老是错误解决方法一: 第一步. 开始--设置--控制面板--双击添加与删除程序,卸载掉flash等相关文件. 第二步. C:WINDOWSsystem32Macrome ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1Aaqz.html" rel="bookmark" class="title">迅雷看看中使电影画面与字幕一致的设置方法</a>
					<div>
						在使用迅雷看看的时候可能会遇到这样的情况,电影跟字幕不一致,看着实在是不舒服,那么怎样调整能使电影跟字幕一致呢,我们可以来看看下面的设置方法. 首先,用迅雷看看打开电影,观察字幕与声音的不匹配度. 成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6AxDz.html" rel="bookmark" class="title">Win7下载软件提示&OpenCurlyDoubleQuote;未知发布者&rdquo;怎么办？</a>
					<div>
						  Win7下载软件提示&quot;未知发布者&quot;怎么办? 1.打开IE浏览器,工具--安全--自定义级别--ActiveX控件和插件; 2.找到&quot;对未标记为可安全执行脚本的Acti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jXr4b.html" rel="bookmark" class="title">js获取location&period;href的参数实例代码</a>
					<div>
						本文为大家介绍下js如何获取location.href的参数,需要注意的是去掉参数里最开头的?号,具体实现如下,有需要的朋友可以参考下,希望对大家有所帮助   window.location.sear ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlYYEb.html" rel="bookmark" class="title">在CentOS系统上查看用户登录记录的方法</a>
					<div>
						  保留.维护和分析日志(如某个特定时期内发生过的,或正在发生的帐号事件),是Linux系统管理员最基础和最重要的任务之一.对于用户管理,检查用户的登入和登出日志(不管是失败的,还是成功的)可以让我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z269b.html" rel="bookmark" class="title">迁移到Windows Server 2012何时收获？</a>
					<div>
						  Windows Server 2012是微软首个大版本的更新,对于那些试图将一些工作负荷移出数据中心的IT人员来说,它提供的一系列增强功能包很有吸引力.这里我们来看看企业何时才能获得利益. 痛苦, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oXWqb.html" rel="bookmark" class="title">宏碁C720P测评</a>
					<div>
						  传统笔记本电脑正在经历一些变革,比如Chromebook的逐渐流行.这种非传统的笔记本,介于平板和电脑之间,运行基于浏览器的Chrome OS,实际上就像是一个全功能的浏览器.并附带存储和网络摄像 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8778p.html" rel="bookmark" class="title">hadoop中典型Writable类详解</a>
					<div>
						Hadoop将很多Writable类归入org.apache.hadoop.io包中,在这些类中,比较重要的有Java基本类.Text.Writable集合.ObjectWritable等,重点介绍J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXQRGp.html" rel="bookmark" class="title">不惧海量数据 软件定义存储助力媒资行业转型</a>
					<div>
						    导读:高清.超高清电视.3D电影.互联网媒体等新应用已经把媒资行业推到IT转型的&quot;风口浪尖&quot;.如何适应当前节目制播模式,主动应对海量数据,在存储空间.应用性能.数据管理和投 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3xK3M.html" rel="bookmark" class="title">如何在实战路上与时俱进：深度学习最佳实践</a>
					<div>
						自2006年Hinton提出神经网络新的训练方法起,深度学习发展迅速,促使人工智能在图像.语音.自然语言处理等多个领域有了实质性的突破,达到产业应用标准.然而,深度学习作为人工智能领域的一项前瞻技术, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Zrdob.html" rel="bookmark" class="title">eclipse下远程调试Hbase</a>
					<div>
						1.准备工作,安装好HABSE之后,执行hbase shell create '表名称', '列名称1','列名称2','列名称N' create '表名称','列族名称' 在HBASE中列是可以动态 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6VANb.html" rel="bookmark" class="title">VR如何巧妙填补传统数据视觉化的漏洞</a>
					<div>
						VR的广泛传播对于数据视觉化具有着可算是屈指可数的地位并因VR发生了天翻地覆的改变.但重点是如何改变?现如今的数据视觉化又发生了哪些问题?这篇文章就此深挖传统视觉化所存在的问题和理解抽象信息中的困难以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA962M.html" rel="bookmark" class="title">activity-如何在java类中访问自定义的对象？</a>
					<div>
						问题描述 如何在java类中访问自定义的对象? 我想在java类中访问自定义的对象,这个java类中包括ApplicationContext 对象. 我创建了一个自定义的应用程序类: class A  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrERKM.html" rel="bookmark" class="title">拓展实践：系统函数的调用</a>
					<div>
						这部分内容可以放在考试后再安排,但上机报告一定要看到. 除了基本的数据类型,C++还定义了一个内容丰富的抽象数据类型标准库.通过使用标准库中的组件,通常可以避免从头到尾来设计自己的IO流,string ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RYaAz.html" rel="bookmark" class="title">深交所延长创业板董监高股票锁定期</a>
					<div>
						简俊东 林铭铭 创业板董事.监事和高管为了套现而离职的现象有望得到遏制. 11月4日下午,深交所发布了&lt;关于进一步规范创业板上市公司董事.监事和高级管理人员买卖本公司股票行为的通知&gt;. 通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgn3Ob.html" rel="bookmark" class="title">MLBase&colon;Spark生态圈里的分布式机器学习系统</a>
					<div>
						MLBase背景 MLBase是Spark生态圈里的一部分,专门负责机器学习这块(除它之外,还有负责图计算的GraphX.SQL ad-hoc查询的Shark.具备容错性查询能力的BlinkDB等). ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmr1kM.html" rel="bookmark" class="title">安全专家教你如何利用Uber系统漏洞无限制的免费乘坐？</a>
					<div>
						本文讲的是安全专家教你如何利用Uber系统漏洞无限制的免费乘坐?,近日,根据外媒报道,美国一名安全研究人员发现Uber上存在一处安全漏洞,允许发现这一漏洞的任何用户在全球范围内免费享受Uber乘车服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RGJqb.html" rel="bookmark" class="title">搭建基于Nagios的监控系统&mdash;&mdash;之监控远程Linux服务器</a>
					<div>
						上一篇介绍了如何安装Nagios Core,这一篇跟大家分享一下如何将一台远程的Linux服务器加入纳入监控范围.   第一部分:在远程Linux上安装Nagios Plugins和NRPE   第一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94584b.html" rel="bookmark" class="title">第一个react native项目</a>
					<div>
						github的地址https://github.com/linhaosheng/React_Parse 该App是解析服务器端的json数据然后进行封装,App的内容包括:图片,小说,视频,电影,服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBAy7z.html" rel="bookmark" class="title">谷歌宣布AdWords广告系统实现移动化</a>
					<div>
						谷歌周四宣布,旗下广告主可以利用http://www.aliyun.com/zixun/aggregation/9429.html&quot;&gt;AdMob网络在3.5亿台移动设备上的30万个应用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNRKqM.html" rel="bookmark" class="title">Facebook发布4种服务器新设计 震撼530亿美元服务器市场</a>
					<div>
						仅用了6年的时间,Facebook的开放计算项目(OCP)就成为数据中心硬件行业里的重要一员,它像邪教一样吸引了无数工程师的追随. Facebook在本周三再次重拳出击,发布了专为公司发明的全新计算机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoyvxM.html" rel="bookmark" class="title">微软与Adobe达成合作 更新Flash Player</a>
					<div>
						[科技讯]11月8日消息,虽然此前有媒体报道,微软饱受诟病的的Patch Tuesday被Update Tuesday取代,该公司要彻底转向Windows8和其核心应用程序.但据国外媒体报道,微软的P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xOK3b.html" rel="bookmark" class="title">Sense：一款能够改善你睡眠质量的床头艺术品</a>
					<div>
						摘要: Maker Voice是为关注新硬件的朋友们准备的一个栏目,初期的形态是每天一篇文章,梳理总结一天下来新硬件行业的精华内容,可能是有意思的产品,也可能是引人思考的观点,目标是让 Maker V ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2GxYz.html" rel="bookmark" class="title">PHP封装分页函数实现文本分页和数字分页&lowbar;php实例</a>
					<div>
						最近,在项目中要用到分页.分页功能是经常使用的一个功能,所以,对其以函数形式进行了封装. // 分页分装/*** $pageType 分页类型 1是数字分页 2是文本分页* 可以将$pageTotal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNQYrp.html" rel="bookmark" class="title">字符编码Unicode、UTF-8和ANSI的详解</a>
					<div>
						NSI.UTF-8.Unicode为字符代码的三种编码格式,一个字符可以被编码成ANSI.UTF-8或Unicode格式,这三种格式只是表现形式不一样,其表示内容是一样的. ANSI.UTF-8.Un ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoPG8M.html" rel="bookmark" class="title">微服务架构设计 &lpar;二&rpar;&colon; 架构迁移策略</a>
					<div>
						在微服务的核心概念中, 最重要的核心概念便是: 边界上下文 (Bounded Context); 每一个微服务拥有各自的某一端到端业务场景 (功能)与数据 (数据库) . 当将既有的架构迁移到微服务时 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
